package com.FranckBarbier._Java._Railcar_control_system;

import com.pauware.pauware_engine._Core.*;
import com.pauware.pauware_engine._Exception.*;
import com.pauware.pauware_engine._Java_EE.*;

@javax.ejb.Stateful
public class TerminalBean implements Terminal {

    /**
     * EJB
     */
    @javax.annotation.Resource
    private javax.ejb.SessionContext _ejb_context = null;
    Terminal _self = null;

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public String get_name() {
        return (_Terminal_state_machine == null) ? TerminalBean.class.getName() : _Terminal_state_machine.name();
    }

    @Override
    public boolean destination_board_is_empty() {
        return _destination_board.isEmpty();
    }

    @javax.annotation.PostConstruct
    public void create() {
        try {
            init_structure();
            init_behavior();
        } catch (Statechart_exception se) {
            java.util.logging.Logger.getLogger(get_name()).log(java.util.logging.Level.SEVERE, null, se);
        }
        assert (_ejb_context != null);
        try {
            _self = _ejb_context.getBusinessObject(Terminal.class);
            // _self = _ejb_context.getEJBObject(); // It does not work...
        } catch (IllegalStateException ise) {
            java.util.logging.Logger.getLogger(get_name()).log(java.util.logging.Level.SEVERE, null, ise);
        }
    }

    @javax.annotation.PreDestroy
    public void destroy() {
        System.out.println(get_name() + " destroyed...");
        try {
            _Terminal_state_machine.stop();
        } catch (Statechart_exception se) {
            java.util.logging.Logger.getLogger(RailcarBean.class.getName()).log(java.util.logging.Level.SEVERE, null, se);
        }
    }

    @javax.ejb.PrePassivate
    public void passivate() {
        System.out.println(get_name() + " passivated...");
    }

    @javax.ejb.PostActivate
    public void activate() {
        System.out.println(get_name() + " activated...");
    }
    /**
     * UML associations
     */
    private java.util.HashSet<Railcar> _clockwise_ingoing_vehicle;
    private java.util.HashSet<Railcar> _counterclockwise_ingoing_vehicle;
    private java.util.HashSet<String> _destination_board;
    /**
     * UML statechart
     */
    private AbstractStatechart _Busy;
    private AbstractStatechart _Idle;
    private AbstractStatechart_monitor _Terminal_state_machine;
    /**
     * UML state machine variables
     */
    private Railcar _my_current_railcar = null;

    /**
     * UML creation
     */
    private void init_structure() throws Statechart_exception {
        _clockwise_ingoing_vehicle = new java.util.HashSet<Railcar>();
        _counterclockwise_ingoing_vehicle = new java.util.HashSet<Railcar>();
        _destination_board = new java.util.HashSet<String>();
    }

    private void init_behavior() throws Statechart_exception {
        _Busy = new Statechart(Terminal.Busy);
        _Busy.set_entryAction(this, "clockwise_ingoing_vehicle_stop");
        _Busy.set_entryAction(this, "counterclockwise_ingoing_vehicle_stop");
        _Idle = new Statechart(Terminal.Idle);
        _Idle.set_entryAction(this, "unset_my_current_railcar");
        _Idle.set_entryAction(this, "clockwise_ingoing_vehicle_go_on");
        _Idle.set_entryAction(this, "counterclockwise_ingoing_vehicle_go_on");
        _Idle.inputState();
        _Terminal_state_machine = new Statechart_monitor(_Busy.xor(_Idle), Terminal.class.getName(), AbstractStatechart_monitor.Show_on_system_out);
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void start(String terminal) throws Statechart_exception {
        _Terminal_state_machine.name(terminal);
        _Terminal_state_machine.fires("time out", _Busy, _Idle, true, this, "to_be_killed");
        _Terminal_state_machine.start();
    }

    /**
     * UML events
     */
    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void alert100(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws Statechart_exception {
        /**
         * UML pre-condition(s)
         */
        /* Downcasting is not satisfactory here: */ assert (_ejb_context.getEJBLocalObject().isIdentical((javax.ejb.EJBLocalObject) terminal));
        _Terminal_state_machine.allowedEvent(Control_center.Alert100, this, "alert100_UML_post_conditions", new Object[]{is_clockwise, railcar});
        _Terminal_state_machine.run_to_completion(Control_center.Alert100);
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void approaching(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws Statechart_exception {
        /**
         * UML pre-condition(s)
         */
        /* Downcasting is not satisfactory here: */ assert (_ejb_context.getEJBLocalObject().isIdentical((javax.ejb.EJBLocalObject) terminal));
        _Terminal_state_machine.fires("approaching", _Idle, _Busy, true, this, "set_my_current_railcar", new Object[]{railcar, is_clockwise});
        _Terminal_state_machine.fires("approaching", _Busy, _Busy);
        _Terminal_state_machine.run_to_completion("approaching");
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void new_destination(String another_terminal) throws Statechart_exception {
        _Terminal_state_machine.allowedEvent("new destination", null, null);
        /**
         * UML post-condition(s)
         */
        _destination_board.add(another_terminal);
        _Terminal_state_machine.run_to_completion("new destination");
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void terminal_crossing(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws Statechart_exception {
        /**
         * UML pre-condition(s)
         */
        /* Downcasting is not satisfactory here: */ assert (_ejb_context.getEJBLocalObject().isIdentical((javax.ejb.EJBLocalObject) terminal));
        assert (_my_current_railcar != null);
        /* Downcasting is not satisfactory here: */ assert (((javax.ejb.EJBLocalObject) _my_current_railcar).isIdentical((javax.ejb.EJBLocalObject) railcar));
        // For simplification, terminals impose their current railcar to stop when terminals' destination board is not empty:
        assert (_destination_board.isEmpty());
        _Terminal_state_machine.fires(Control_center.Terminal_crossing, _Busy, _Idle, true, railcar, "terminal_crossing");
        _Terminal_state_machine.run_to_completion(Control_center.Terminal_crossing);
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void terminal_stopping(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws Statechart_exception {
        /**
         * UML pre-condition(s)
         */
        /* Downcasting is not satisfactory here: */ assert (_ejb_context.getEJBLocalObject().isIdentical((javax.ejb.EJBLocalObject) terminal));
        assert (_my_current_railcar != null);
        /* Downcasting is not satisfactory here: */ assert (((javax.ejb.EJBLocalObject) _my_current_railcar).isIdentical((javax.ejb.EJBLocalObject) railcar));
        /**
         * UML post-condition(s)
         */
        // For simplification, terminals impose their current railcar to stop when terminals' destination board is not empty:
        _destination_board.removeAll(_destination_board);
        _Terminal_state_machine.fires(Control_center.Terminal_stopping, _Busy, _Busy, true, this, "to_be_set", new Object[]{Terminal.Parking_time});
        _Terminal_state_machine.fires(Control_center.Terminal_stopping, _Busy, _Busy, true, _my_current_railcar, "terminal_stopping");
        _Terminal_state_machine.run_to_completion(Control_center.Terminal_stopping);
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public void time_out(long delay, AbstractStatechart context) throws Statechart_exception {
        _Terminal_state_machine.fires("time out", _Busy, _Idle, true, _my_current_railcar, "go");
        _Terminal_state_machine.run_to_completion("time out");
    }

    @Override
    public void time_out_error(Statechart_exception se) {
        // PauWare compatibility
        // This method is never called by the Stateless Session Bean, which provides timer services
    }

    /**
     * UML actions
     */
    public void alert100_UML_post_conditions(Boolean is_clockwise, Railcar railcar) {
        if (is_clockwise) {
            _clockwise_ingoing_vehicle.add(railcar);
        }
        if (!is_clockwise) {
            _counterclockwise_ingoing_vehicle.add(railcar);
        }
    }

    public void clockwise_ingoing_vehicle_go_on() throws Statechart_exception {
        java.util.Iterator<Railcar> i = _clockwise_ingoing_vehicle.iterator();
        while (i.hasNext()) {
            i.next().go_on();
        }
    }

    public void counterclockwise_ingoing_vehicle_go_on() throws Statechart_exception {
        java.util.Iterator<Railcar> i = _counterclockwise_ingoing_vehicle.iterator();
        while (i.hasNext()) {
            i.next().go_on();
        }
    }

    public void clockwise_ingoing_vehicle_stop() throws Statechart_exception {
        java.util.Iterator<Railcar> i = _clockwise_ingoing_vehicle.iterator();
        while (i.hasNext()) {
            i.next().stop();
        }
    }

    public void counterclockwise_ingoing_vehicle_stop() throws Statechart_exception {
        java.util.Iterator<Railcar> i = _counterclockwise_ingoing_vehicle.iterator();
        while (i.hasNext()) {
            i.next().stop();
        }
    }

    public void set_my_current_railcar(Railcar railcar, Boolean is_clockwise) {
        boolean found = (is_clockwise ? _clockwise_ingoing_vehicle.remove(railcar) : true);
        found &= (!is_clockwise ? _counterclockwise_ingoing_vehicle.remove(railcar) : true);
        assert (found);

        assert (_my_current_railcar == null);
        _my_current_railcar = railcar;
        assert (_my_current_railcar != null);

        /**
         * Simulation
         */
        String terminal_name = _Terminal_state_machine.name();
        String railcar_name = _my_current_railcar.get_name();

        // System.out.println("set_my_current_railcar " + terminal_name + "<-" + railcar_name);
        assert (_queue_connection_factory != null && _queue != null); // Dependency injection succeeded!
        try {
            _queue_connection = _queue_connection_factory.createQueueConnection();
            _queue_session = _queue_connection.createQueueSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
            _queue_sender = _queue_session.createSender(_queue);
            if (_my_current_railcar.has_for_destination(terminal_name)) {
                _queue_sender.send(_queue_session.createTextMessage(Control_center.Terminal_stopping + Control_center.Message_separator + terminal_name + Control_center.Message_separator + railcar_name + Control_center.Message_separator + (is_clockwise ? "1" : "0")));
            } else {
                // For simplification, terminals impose their current railcar to stop when terminals' destination board is not empty
                // This solution does not require knowledge on the topography. If so, the decision making process must move to the 'Control_center' EJB 
                if (_destination_board.isEmpty()) {
                    _queue_sender.send(_queue_session.createTextMessage(Control_center.Terminal_crossing + Control_center.Message_separator + terminal_name + Control_center.Message_separator + railcar_name + Control_center.Message_separator + (is_clockwise ? "1" : "0")));
                } else {
                    _queue_sender.send(_queue_session.createTextMessage(Control_center.Terminal_stopping + Control_center.Message_separator + terminal_name + Control_center.Message_separator + railcar_name + Control_center.Message_separator + (is_clockwise ? "1" : "0")));
                }
            }
            _queue_connection.close();
        } catch (javax.jms.JMSException jmse) {
            java.util.logging.Logger.getLogger(get_name()).log(java.util.logging.Level.SEVERE, null, jmse);
        }
    }

    public void unset_my_current_railcar() {
        assert (_my_current_railcar != null);
        _my_current_railcar = null;
    }

    // For reliability reasons, timer services cannot rely on PauWare that uses the Java SE API
    // One requires timer services from a Stateless Session Bean because 'TerminalBean' is stateful
    // One keeps PauWare's style:
    public void to_be_set(Long delay) throws com.pauware.pauware_engine._Exception.Statechart_exception {
        Timer timer;
        try {
            timer = (Timer) (new javax.naming.InitialContext()).lookup("java:global/Railcar_control_system_Java_EE_6/Timer");
        } catch (javax.naming.NamingException ne) {
            throw new com.pauware.pauware_engine._Exception.Statechart_exception(ne.getMessage());
        } catch (ClassCastException cce) {
            throw new com.pauware.pauware_engine._Exception.Statechart_exception(cce.getMessage());
        }

        assert (_self != null);

        timer.to_be_set(_self, delay);
    }

    public void to_be_killed() {
        // Timer in the Stateless Session Bean has been created as "single action timer"
        // So, nothing more is required here
    }

    /**
     * Management
     */
    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public String async_current_state() {
        return _Terminal_state_machine.async_current_state();
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public String current_state() {
        return _Terminal_state_machine.current_state();
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public boolean in_state(String name) {
        return _Terminal_state_machine.in_state(name);
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public String name() {
        return _Terminal_state_machine.name();
    }

    @Override
    @javax.ejb.TransactionAttribute(javax.ejb.TransactionAttributeType.NOT_SUPPORTED)
    public String verbose() {
        return _Terminal_state_machine.verbose();
    }
    /**
     * Simulation
     */
    /**
     * JMS
     */
    @javax.annotation.Resource(mappedName = "jms/Control_center_queue_factory")
    private javax.jms.QueueConnectionFactory _queue_connection_factory;
    @javax.annotation.Resource(mappedName = "jms/Control_center_queue")
    private javax.jms.Queue _queue;
    transient private javax.jms.QueueConnection _queue_connection;
    transient private javax.jms.QueueSession _queue_session;
    transient private javax.jms.QueueSender _queue_sender;
}
