package com.FranckBarbier._Java._Railcar_control_system;

// Note: this Stateless Session Bean is introduced only for providing timer services
// It will be used by 'Terminal' beans, which cannot use PauWare timers or EJB native timer services because of passivation
@javax.ejb.Stateless
@javax.ejb.LocalBean
public class Timer {

    /**
     * EJB
     */
    @javax.annotation.Resource
    private javax.ejb.TimerService _timer_service = null;

    @javax.annotation.PostConstruct
    public void create() {
        assert (_timer_service != null); // Dependency injection has succeeded!       
    }

    @javax.annotation.PreDestroy
    public void destroy() {
    }

    public void to_be_set(Terminal terminal, long delay) throws com.pauware.pauware_engine._Exception.Statechart_exception {
        // System.out.println(Timer.class.getName() + ".to_be_set: " + delay);
        try {
            // This code relies on the fact that Stateful Session Beans are serializable:
            _timer_service.createSingleActionTimer(delay, new javax.ejb.TimerConfig((java.io.Serializable) terminal, false));
        } catch (ClassCastException cce) {
            throw new com.pauware.pauware_engine._Exception.Statechart_exception(cce.getMessage());
        }
    }

    @javax.ejb.Timeout
    public void time_out(javax.ejb.Timer timer) throws com.pauware.pauware_engine._Exception.Statechart_exception {
        // System.out.println(Timer.class.getName() + ".time_out");
        Terminal terminal;
        try {
            // This code relies on the fact that Stateful Session Beans are serializable:
            terminal = (Terminal) timer.getInfo();
        } catch (ClassCastException cce) {
            throw new com.pauware.pauware_engine._Exception.Statechart_exception(cce.getMessage());
        }
        // PauWare callback style, parameters are not used by 'Terminal' beans
        terminal.time_out(Terminal.Parking_time, null);
    }
}
