package com.FranckBarbier._Java._Railcar_control_system;

@javax.ejb.MessageDriven(mappedName = "jms/Control_center_queue", activationConfig = {
    @javax.ejb.ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
    @javax.ejb.ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class Topography implements javax.jms.MessageListener {

    private static java.util.Map<String, String[]> _Messages = new java.util.Hashtable<String, String[]>();
    /**
     * EJB
     */
    @javax.ejb.EJB
    private Control_center_local _control_center = null;

    @javax.annotation.PostConstruct
    public void create() {
        assert (_control_center != null);
    }

    @Override
    public void onMessage(javax.jms.Message message) {
        if (message instanceof javax.jms.TextMessage) {
            try {
                String[] text_message = ((javax.jms.TextMessage) message).getText().split(Control_center.Message_separator);

                assert (text_message != null && text_message.length == 4);
                assert (text_message[3].equals("0") || text_message[3].equals("1"));

                // System.out.println(this.toString() + " onMessage - " + text_message[0] + ": " + text_message[2] + " -> " + text_message[1] + " " + (text_message[3].equals("0") ? "false" : "true"));
                if (text_message[0].equals(Control_center.Alert100)) {
                    _control_center.alert100(text_message[1], text_message[2], text_message[3].equals("0") ? false : true);
                    _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Alert100, text_message);
                    String[] alert80_message = _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                    if (alert80_message != null) {
                        _control_center.alert80(alert80_message[1], alert80_message[2], alert80_message[3].equals("0") ? false : true);
                        _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Alert80, text_message);
                        String[] terminal_crossing_message = _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Terminal_crossing);
                        if (terminal_crossing_message != null) {
                            _control_center.terminal_crossing(terminal_crossing_message[1], terminal_crossing_message[2], terminal_crossing_message[3].equals("0") ? false : true);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                        }
                        String[] terminal_stopping_message = _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Terminal_stopping);
                        if (terminal_stopping_message != null) {
                            _control_center.terminal_stopping(terminal_stopping_message[1], terminal_stopping_message[2], terminal_stopping_message[3].equals("0") ? false : true);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                        }

                        assert (terminal_crossing_message == null || terminal_stopping_message == null);

                    }
                }
                if (text_message[0].equals(Control_center.Alert80)) {
                    boolean alert100 = _Messages.containsKey(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                    if (alert100) {
                        _control_center.alert80(text_message[1], text_message[2], text_message[3].equals("0") ? false : true);
                        _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Alert80, text_message);
                        String[] terminal_crossing_message = _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Terminal_crossing);
                        if (terminal_crossing_message != null) {
                            _control_center.terminal_crossing(terminal_crossing_message[1], terminal_crossing_message[2], terminal_crossing_message[3].equals("0") ? false : true);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                        }
                        String[] terminal_stopping_message = _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Terminal_stopping);
                        if (terminal_stopping_message != null) {
                            _control_center.terminal_stopping(terminal_stopping_message[1], terminal_stopping_message[2], terminal_stopping_message[3].equals("0") ? false : true);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                            _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                        }

                        assert (terminal_crossing_message == null || terminal_stopping_message == null);

                    } else {
                        _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Alert80, text_message);
                    }
                }
                if (text_message[0].equals(Control_center.Terminal_crossing)) {
                    boolean alert100 = _Messages.containsKey(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                    boolean alert80 = _Messages.containsKey(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                    if (alert80 && alert100) {
                        _control_center.terminal_crossing(text_message[1], text_message[2], text_message[3].equals("0") ? false : true);
                        _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                        _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                    } else {
                        _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Terminal_crossing, text_message);
                    }
                }
                if (text_message[0].equals(Control_center.Terminal_stopping)) {
                    boolean alert100 = _Messages.containsKey(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                    boolean alert80 = _Messages.containsKey(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                    if (alert80 && alert100) {
                        _control_center.terminal_stopping(text_message[1], text_message[2], text_message[3].equals("0") ? false : true);
                        _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert100);
                        _Messages.remove(text_message[2] + Control_center.Message_separator + Control_center.Alert80);
                    } else {
                        _Messages.put(text_message[2] + Control_center.Message_separator + Control_center.Terminal_stopping, text_message);
                    }
                }
            } catch (Exception e) {
                java.util.logging.Logger.getLogger(Topography.class.getName()).log(java.util.logging.Level.SEVERE, null, e);
            }
        }
    }
}
